/* Demo program printing powers of BASE modulo MODULUS from 0 to EXPONENTS.

   Copyright 2002, 2007 Kevin Ryde

   This file is part of MPM.

   MPM is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2, or (at your option) any later version.

   MPM is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with MPM; see the file COPYING.  If not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
   USA.  */

#include <stdio.h>
#include "gmp.h"

#include "mpm.h"


#define BASE       "2"
#define MODULUS    "11"
#define EXPONENTS  11

int
main (void)
{
  mpm_t  m;
  mpr_t  r, b;
  mpz_t  rz;
  int    i;

  printf ("modulo %s\n", MODULUS);

  mpm_init_str (m, MODULUS, 0);
  mpr_init_set_str (b, BASE, 0, m);
  mpr_init (r, m);
  mpz_init (rz);

  for (i = 0; i <= EXPONENTS; i++)
    {
      mpr_pow_ui (r, b, (unsigned long) i, m);
      mpr_get_z (rz, r, m);
      gmp_printf ("%s^%d = %Zd", BASE, i, rz);

      mpr_invert (r, r, m);
      mpr_get_z (rz, r, m);
      gmp_printf ("  %s^-%d = %Zd\n", BASE, i, rz);
    }

  mpr_clear (r, m);
  mpr_clear (b, m);
  mpm_clear (m);
  mpz_clear (rz);

  return 0;
}
